/** \file inclinometer.cpp 
 * \brief All tools to get inclinometer value on each axis.
 * \details See also : \n \n inclinometer.h \n The header File Reference.*/

/* Get inclinometer value for axis X or Y */

#include "inclinometer.h"


// Return Roll (around the X axis)
float  GetRoll ()
{
#ifdef __DEBUG__INCLINOMETER__
	Serial.println("Getting roll...");
#endif

	float VoutX = analogRead(A1);						// Read analog value return by the inclinometer for X axis
	return -asin (( ((VoutX*5.0)/1023.0) -2.5) /2.0);	// Return the angle
}


// Return Pitch (around the Y axis)
float GetPitch()
{
#ifdef __DEBUG__INCLINOMETER__
	Serial.println("Getting pitch...");
#endif

	float VoutY = analogRead(A0);						// Read analog value return by the inclinometer for Y axis
	return -asin (( ((VoutY*5.0)/1023.0) -2.5) /2.0);	// Return the angle
}



