/**\file pcf8574.cpp
 * \brief Controls leds and buttons using a port expander.
 * \detail See also : \n \n pcf8574.h \n The header File Reference.*/


#include <TimerOne.h>
#include <pcf8574.h>

 	 
bool Flag=false;						// The time out flag

// Writes a value to the port expander pins 1 means high, 0 means low. The last bit is a write bit 1 to write.
void ExpanderWrite(unsigned char _data ) 
{
  Wire.beginTransmission(expander);
  Wire.send(_data);
  Wire.endTransmission();     
}


// Read function reads ports on pcf8574 returns a byte of data one bit for pin
// If a pre-set TimeOut is reached the functions returns a value of -5
// TimeOut can be set in  microseconds
// If the transmission is successful the port data is returned 
// If there are transmission errors the function returns Arduino values for i2c -1 >>>-5
// Reports back staus of  transmission  activity as per Arduino wire.h library
// 0 = not pressed,1 pressed, -1 =data too long to fit in transmit buffer
// -2 =recieved NACK on transmit address ,
// -3 =recieved NACK on transmit data,-4 =other error, -5 Timeout 

int  ExpanderRead(int TimeOut) 
{
      byte _data=0;
      Wire.requestFrom(expander, 1);
      Flag=false;
      Timer1.initialize(TimeOut);
      Timer1.attachInterrupt(ISR_Interrupt);
      Timer1.start();
            
     
     do
     {
       if(Wire.available())
       {
           _data=Wire.receive();
           return _data;
       }
     }
     while(Flag==0);
     Timer1.detachInterrupt();                        
                                
     Timer1.stop();
     Flag=false;
     return -5;    
}

char Button1(){ 
	char  b; 
	  char e ;  
	      
              e = Wire.endTransmission();
              b = ExpanderRead(100000) ; 
#ifdef __DEBUG__LEDS__BUTTONS__
              Serial.println(ExpanderRead(100000), BIN);
#endif
              b = b & 0xF0;
	            if (e >0)   return -e;
                if (b == 0XA0){
                        return -5;}
             
               else if ( b & (1<<4)){        
                return 0; }  
            else  {    
              return 1;}
          
 }











  
char Button2(){ 
	char  b; 
	  char e ;  
	      
              e = Wire.endTransmission();
              b = ExpanderRead(100000); 
              b = b & 0xF0;
	            if (e >0)   return -e;
                if (b == 0XA0)  return -5;
             
                if ( b & (1<<5)){
	                      
                return 0; }  
            else  {    
              return 1;}
          
 }
 char Button3(){ 
	char  b; 
	  char e ;  
	      
              e = Wire.endTransmission();
              b = ExpanderRead(100000); 
              b = b & 0xF0;
	            if (e >0)   return -e;
                if (b == 0XA0)  return -5;
             
                if ( b & (1<<6)){
	                      
                return 0; }  
            else  {    
              return 1;}
          
 }
  char Button4(){ 
	char  b; 
	 char e ;  
	      
              e = Wire.endTransmission();
              b = ExpanderRead(100000); 
             b = b & 0xF0; 
	            if (e >0)   return -e;
                if (b == 0XA0)  return -5;
             
                if ( b & (1<<7)){
	                      
                return 0; }  
            else  {    
              return 1;}
          
 }
//Char b is expander value before any action is taken
//Write an instruction to led OFF or ON 
// Reports back staus of  transmission  activity as per Arduino wire.h library
// 0 = Success, 1 =data too long to fit in transmit buffer
// 2 =recieved NACK on transmit address ,
// 3 =recieved NACK on transmit data,4 =other error


 
char Led1(char state){        
                  char b;
                  b = ExpanderRead(10000);  
                  if (state == 0){
                         ExpanderWrite( b | (1<<0));        
                   }
                   else{
                         ExpanderWrite(b & (0<<0)); 
                   }
                  delay(100);
                  char e;       
                  char status = Wire.endTransmission();
	              if (status >0){
                        return -status;
                   }
                   else{
                        return 0;
                   }
}
char Led2(char state){        
                  char b;
                  b = ExpanderRead(10000);  
                  if (state == 0){
                         ExpanderWrite( b | (1<<1));        
                   }
                   else{
                         ExpanderWrite(b & (0<<0)); 
                   }
                  delay(100);
                  char e;       
                  char status = Wire.endTransmission();
	              if (status >0){
                        return -status;
                   }
                   else{
                        return 0;
                   }
}
char Led3(char state){        
                  char b;
                  b = ExpanderRead(10000);  
                  if (state == 0){
                         ExpanderWrite( b | (1<<2));        
                   }
                   else{
                         ExpanderWrite(b & (0<<0)); 
                   }
                  delay(100);
                  char e;       
                  char status = Wire.endTransmission();
	              if (status >0){
                        return -status;
                   }
                   else{
                        return 0;
                   }
} 
char Led4(char state){        
                  char b;
                  b = ExpanderRead(10000);  
                  if (state == 0){
                         ExpanderWrite( b | (1<<3));        
                   }
                   else{
                         ExpanderWrite(b & (0<<0)); 
                   }
                  delay(100);
                  char e;       
                  char status = Wire.endTransmission();
	              if (status >0){
                        return -status;
                   }
                   else{
                        return 0;
                   }
}/*
bool Led2(){
     b= ExpanderRead()== 0x0B;
     return ~b;
  
}
bool Led3(){
     b= ExpanderRead()== 0x0D;
     return ~b;
  
}

bool Led4(){
     b= ExpanderRead()== 0x0E;
     return ~b;
  
}

*/



void ISR_Interrupt()
 { Flag=true;
     Timer1.detachInterrupt();
     
   
 
    
 }     

















